import libglade
import gtk
import GDK
import string
import re
import time
from core import *
import urllib 
from image import *

not_available_string = "[n/a]"

class Contact(FamiliarClass):
    def __init__(self):
        self.mimetype = "application/x-contact"
        self.name = [] # Format should be first,last,middle,title,company,nickname
        self.physical_addresses = []
        self.phone_numbers = []
        self.email_addresses = []
        self.birthdate = None
        self.image = None
        FamiliarClass.__init__(self)

    def set_name(self, name):
        for i in range(0,len(name)):
            if i >= len(self.name):
                self.name.append(name[i])
            else:
                self.name[i] = name[i]

    def get_name(self):
        return self.name[:]

    def set_image(self, image):
        self.image = image

    def get_image(self):
        return self.image

    def set_physical_addresses(self, addresses):
        self.physical_addresses = addresses
        
    def get_physical_addresses(self):
        return self.physical_addresses

    def set_phone_numbers(self, phone_numbers):
        self.phone_numbers = phone_numbers
        
    def get_phone_numbers(self):
        return self.phone_numbers

    def set_email_addresses(self, email_addresses):
        self.email_addresses = email_addresses

    def get_email_addresses(self):
        return self.email_addresses

    def set_birthdate(self, birthdate):
        self.birthdate = birthdate
        
    def get_birthdate(self):
        return self.birthdate

    def new_view(self):
        # XXX - This should be routed through the ObjectManager
        return ContactView(self)

    def get_printable_name(self):
        # XXX - This needs to be moved into the view.
        name = self.get_name()
#        name.reverse()
        full_name = string.join([name[1], name[0]], ", ")
        
        return full_name
    

class ContactView(FamiliarClassView):
    def __init__(self, object):
        self.object = object
        self.callback_object_list = []
        FamiliarClassView.__init__(self)

    # XXX - This needs to become a clean API that all of the object
    # views share.
    
    def register_callback(self, callback_object, type=None):
        self.callback_object_list.append(callback_object)

    def notify_registered_callbacks(self, *args):
        for callback in self.callback_object_list:
            callback.notify_callback(self)
        
    def view(self,function):
        self.helper = GladeHelper("familiar/contact.glade",
                                  ContactSignalHandler)


        contactwindow = self.helper["contactwindow"]
        contactwindow.set_default_size(240,320)
        
        width=gtk.screen_width()
        height=gtk.screen_height()
        if width >=640 and height >= 480:
            pass
        else:
            width=width-20
            height=height-40
            contactwindow.set_default_size(width,height)

        edit_button = self.helper["edit_button"]
        edit_button.set_data("view",self)

        cancel_button = self.helper["cancel_button"]
        cancel_button.set_data("view",self)

        save_button = self.helper["save_button"]
        save_button.set_data("view",self)

        close_button = self.helper["close_button"]
        close_button.set_data("view",self)

        close2_button = self.helper["close2_button"]
        close2_button.set_data("view",self)

        if function == "view":
            self.refresh_view()
        elif function == "edit":
            self.edit_contact_tab()
        else:
            pass

    def refresh_view(self):
        main_frame = self.helper["main_frame"]
        main_frame.set_label(self.object.get_printable_name())
        
        addresses = []
        addresses = self.object.get_physical_addresses()
        addresses_frame = self.helper["addresses_frame"]
        address_list = self.helper["address_list"]
        
        address_list.clear_items(0,len(address_list.children()))
        item_list = []

        tmp = 0
        for address in addresses:    
            if not address:
                continue
            widget = gtk.GtkListItem(address)
            widget.set_data("address",address)
            widget.set_data("view",self)
            widget.show()
            item_list.append(widget)
            tmp += 1
            
        addresses_frame.show()
    
        if not tmp:
            widget = gtk.GtkListItem(not_available_string)
            widget.show()
            item_list.append(widget)
            
        address_list.append_items(item_list)
        addresses_frame.show()

        phone_numbers = []
        phone_numbers = self.object.get_phone_numbers()
        phone_numbers_list = self.helper["phone_list"]
        phone_numbers_frame = self.helper["phone_numbers_frame"]

        phone_numbers_list.clear_items(0,len(phone_numbers_list.children()))
        item_list = []

        tmp = 0
        for phone_number in phone_numbers:
            if not phone_number:
                continue
            
            widget = gtk.GtkListItem(phone_number)
            widget.show()
            item_list.append(widget)
            tmp += 1

        if not tmp:
            widget = gtk.GtkListItem(not_available_string)
            widget.show()
            item_list.append(widget)

        phone_numbers_list.append_items(item_list)
        phone_numbers_frame.show()

        email_addresses = self.object.get_email_addresses()
        email_addresses_frame = self.helper["email_addresses_frame"]
        email_addresses_list = self.helper["email_list"]
        
        email_addresses_list.clear_items(0,len(email_addresses_list.children()))
        item_list = []

        tmp = 0
        for email in email_addresses:
            if not email:
                continue
            
            widget = gtk.GtkListItem(email)
            widget.show()
            item_list.append(widget)
            tmp += 1
            
        if not tmp:
            widget = gtk.GtkListItem(not_available_string)
            widget.show()
            item_list.append(widget)


        email_addresses_list.append_items(item_list)
        email_addresses_frame.show()

        birthdate = self.object.get_birthdate()
        birthdate_label = self.helper["birthdate_label"]
        birthdate_frame = self.helper["birthdate_frame"]

        if birthdate:
            birthdate_label.set_text(birthdate)
        else:
            birthdate_label.set_text(not_available_string)

        
        # XXX -- Hokey as hell.
        image = self.object.get_image()
        picture_frame = self.helper["picture_frame"]

        widget = image.new_view().get_widget()
        widget.show()
        children = []
        children = picture_frame.children()
        if len(children):
            picture_frame.remove(children[0])
        picture_frame.add(widget)

    def edit_contact_tab(self):
        name = []
        address = []
        physical_address = []
        phones_numbers = []
        email_addresses = []

        self.helper["name_button"].set_data("view",self)
        self.helper["name_button"].set_data("name","name")
        
        self.helper["address_button"].set_data("view",self)
        self.helper["address_button"].set_data("name","address")
        
        self.helper["phone_button"].set_data("view",self)
        self.helper["phone_button"].set_data("name","phone")
        
        self.helper["email_button"].set_data("view",self)
        self.helper["email_button"].set_data("name","email")
        
        self.helper["address1_1"].set_data("view",self)
        
        notebook = self.helper["notebook1"]
        notebook.set_page(1)

        firstname = self.helper["firstname"]
        lastname = self.helper["lastname"]
        middlename = self.helper["middlename"]
        titlename = self.helper["titlename"]
        companyname = self.helper["companyname"]
        nickname = self.helper["nickname"]

        name = self.object.get_name()
        if name:
            firstname.set_text(name[0])
            lastname.set_text(name[1])
            if len(name) >= 3:
                if name[2] != None:
                    middlename.set_text(name[2])
            if len(name) >= 4:
                if name[3] != None:
                    titlename.set_text(name[3])
            if len(name) >= 5:
                if name[4] != None:
                    companyname.set_text(name[4])
            if len(name) >= 6:
                if name[5] != None:
                    nickname.set_text(name[5])                               
        else:
            self.helper["edit_frame"].set_label("Add A New Contact")
            self.helper["cancel_button"].hide()
            self.helper["close2_button"].show()

        physical_addresses  = self.object.get_physical_addresses()

        widget_array = [ self.helper["address1_1"],
                         self.helper["address1_2"],
                         self.helper["address2_1"],
                         self.helper["address2_2"],
                         self.helper["address3_1"],
                         self.helper["address3_2"],
                         self.helper["address4_1"],
                         self.helper["address4_2"]]

        i = 0
        for address in physical_addresses:
            if not address:
                continue
            
            part1, part2 = address.split("\n")
            widget_array[i].set_text(part1)
            widget_array[i + 1].set_text(part2)

            i += 2

        phone_numbers = self.object.get_phone_numbers()
        if phone_numbers:
            phone1 = self.helper["phone1"]
            work_phone = self.helper["work_phone"]
            cell_phone = self.helper["cell_phone"]
            pager_phone = self.helper["pager_phone"]
            
            if len(phone_numbers) >= 1:
                if phone_numbers[0] != None:
                    phone1.set_text(phone_numbers[0])
            if len(phone_numbers) >= 2:
                if phone_numbers[1] != None:
                    work_phone.set_text(phone_numbers[1])
            if len(phone_numbers) >= 3:
                if phone_numbers[2] != None:
                    cell_phone.set_text(phone_numbers[2])
            if len(phone_numbers) >= 4:
                if phone_numbers[3] != None:
                    pager_phone.set_text(phone_numbers[3])

        email_address = self.object.get_email_addresses()
        if email_address:
            email1 = self.helper["email1"]
            if len(email_address) > 0:
                if email_address[0] != None:
                    email1.set_text(email_address[0])                           

        if self.object.get_birthdate():
            birthdate = self.helper["birthdate"]
            birthdate.set_text(self.object.get_birthdate())

        if self.object.get_image():
            imagefile = self.helper["imagefile"]
            imagefile.set_text(self.object.get_image().get_filename())

    def more_contact_info_tab(self,name):
        if name == "name":
            self.helper["names_cancel_button"].set_data("view",self)
            self.helper["names_save_button"].set_data("view",self)
            self.helper["notebook1"].set_page(2)
            
        elif name == "address":
            self.helper["address_cancel_button"].set_data("view",self)
            self.helper["address_save_button"].set_data("view",self)
            self.helper["notebook1"].set_page(3)
                
        elif name == "phone":
            self.helper["phones_cancel_button"].set_data("view",self)
            self.helper["phone_save_button"].set_data("view",self)
            self.helper["notebook1"].set_page(4)
            
        elif name == "email":
            self.helper["email_cancel_button"].set_data("view",self)
            self.helper["email_save_button"].set_data("view",self)
            self.helper["notebook1"].set_page(5)
            
        else:
            pass
        
    def save_contact(self):
        firstname = self.helper["firstname"]
        lastname = self.helper["lastname"]
        middlename = self.helper["middlename"]
        titlename = self.helper["titlename"]
        companyname = self.helper["companyname"]
        nickname = self.helper["nickname"]

        name = [firstname.get_text(),lastname.get_text()]
        if middlename.get_text():
            name.append(middlename.get_text())
        else:
            name.append("")
        if titlename.get_text():
            name.append(titlename.get_text())
        else:
            name.append("")
        if companyname.get_text():
            name.append(companyname.get_text())
        else:
            name.append("")
        if nickname.get_text():
            name.append(nickname.get_text())
        else:
            name.append("")
            
        self.object.set_name(name)

        address1_1 = self.helper["address1_1"]                              
        address1_2 = self.helper["address1_2"]
        address2_1 = self.helper["address2_1"]
        address2_2 = self.helper["address2_2"]
        address3_1 = self.helper["address3_1"]                              
        address3_2 = self.helper["address3_2"]
        address4_1 = self.helper["address4_1"]
        address4_2 = self.helper["address4_2"]

        address = []
        if address1_1.get_text() and address1_2.get_text():
            temp = "%s\n%s" % (address1_1.get_text(), address1_2.get_text())
            address.append(temp)
        else:
            address.append(None)

        if address2_1.get_text() and address2_2.get_text():
            temp = "%s\n%s" % (address2_1.get_text(), address2_2.get_text())
            address.append(temp)
        else:
            address.append(None)

        if address3_1.get_text() and address3_2.get_text():
            temp = "%s\n%s" % (address3_1.get_text(), address3_2.get_text())
            address.append(temp)
        else:
            address.append(None)

        if address4_1.get_text() and address4_2.get_text():
            temp = "%s\n%s" % (address4_1.get_text(), address4_2.get_text())
            address.append(temp)
        else:
            address.append(None)

        self.object.set_physical_addresses(address)
        
        phone1 = self.helper["phone1"]
        work_phone = self.helper["work_phone"]
        cell_phone = self.helper["cell_phone"]
        pager_phone = self.helper["pager_phone"]

        phones = []
        if phone1.get_text():
            phones.append(phone1.get_text())
        else:
            phones.append(None)

        if work_phone.get_text():
            phones.append(work_phone.get_text())
        else:
            phones.append(None)

        if cell_phone.get_text():
            phones.append(cell_phone.get_text())
        else:
            phones.append(None)

        if pager_phone.get_text():
            phones.append(pager_phone.get_text())
        else:
            phones.append(None)

        self.object.set_phone_numbers(phones)
            
        email1 = self.helper["email1"]
        work_email = self.helper["work_email"]
        school_email = self.helper["school_email"]
        other_email = self.helper["other_email"]

        emails = []
        if email1.get_text():
            emails.append(email1.get_text())
        else:
            emails.append(None)

        if work_email.get_text():
            emails.append(work_email.get_text())
        else:
            emails.append(None)

        if school_email.get_text():
            emails.append(school_email.get_text())
        else:
            emails.append(None)

        if other_email.get_text():
            emails.append(other_email.get_text())
        else:
            emails.append(None)

        self.object.set_email_addresses(emails)
        
        birthdate = self.helper["birthdate"]
        if birthdate.get_text():
            self.object.set_birthdate(birthdate.get_text())
        else:
            self.object.set_birthdate(None)
           
        imagefile = self.helper["imagefile"]
        image = self.object.get_image()

        if imagefile.get_text():
            image.set_filename(imagefile.get_text())
        else:
            image.set_filename("images/nobody.jpeg")

        self.object.set_image(image)


        self.refresh_view()
        self.back_to_contact_view()

        self.notify_registered_callbacks("update")
        
    def back_to_contact_view(self):
        notebook = self.helper["notebook1"]
        notebook.set_page(0)

    def back_to_contact_edit(self,name):
        self.helper["notebook1"].set_page(1)

    def close_contact_window(self):
        window = self.helper["contactwindow"]
        window.destroy()

    def search_for_possible_addresses(self,widget):
        name = widget.get_name()
        combo_name = "%s_combo" % (name)
        print combo_name
        list = [widget.get_text(),"Foo","Bar","Eek","Oook"]
        self.helper[combo_name].set_popdown_strings(list)
        
    
    def get_directions(self,address_to):
        
        directions_back = self.helper["directions_back"]
        directions_back.set_data("view",self)
        
        directions_list = self.helper["directions_list"]
        directions_list.set_point(0)
        chars = directions_list.get_length()
        directions_list.forward_delete(chars)
        
        directions_list.set_line_wrap(1)
        directions_list.set_word_wrap(1)
        
        directions_list.freeze()
        
	# Default to me for right now
	street0="380+Larcom+st"
	city0="Thousand+Oaks"
	state0="CA"
	# Yank out and convert the info we need
	part1, part2 = address_to.split("\n")
	street1=re.sub("\ ","+",part1)
	part3, part4 = part2.split(",")
	city1=re.sub("\ ","+",part3)
	state1=part4[1:3]
        
        if street1 == street0:
            directions_list.insert_defaults("[Same Address]")
            return

	url = "http://www.mapquest.com/cgi-bin/mqtrip?link=btwn/twn-ddir_na_basic_main&addr_0=%s&city_0=%s&state_0=%s&cc_0=US&addr_1=%s&city_1=%s&state_1=%s&cc_1=US" % (street0,city0,state0,street1,city1,state1)
        
	f = urllib.urlopen(url)
    
        # Direction lines regexs
	pat = re.compile("\s+\d+\:$")
	pat2 = re.compile("^\s+")
	pat3 = re.compile("\&nbsp\;\s+")

        # Total lines regexs
        total_time_pat = re.compile("^\s+\&nbsp\;TOTAL ESTIMATED")
        
	contents = f.readlines()
	matches = []
        found_extras = 0
        extras = []
        count = 0
	for content in contents:
            m = pat.match(content)
            m2 = total_time_pat.match(content)
            
            if m:
                # Grab the number
                content = re.sub(pat2,"",content)
                content = re.sub("$\n","",content)

                # Grab the directions
                contents[count+3] = re.sub(pat2,"",contents[count+3])
                contents[count+3] = re.sub("</td>","",contents[count+3])

                # Grab the milage
                contents[count+5] = re.sub(pat2,"",contents[count+5])
                tmp = contents[count+5]
                contents[count+5] = re.sub(pat3,"",tmp)
#                contents[count+5] = re.sub("\n","",contents[count+5])

                line = []
                line.append(content)
                line.append(contents[count+3])
                line.append(contents[count+5])
                matches.append(line)
            elif m2:
                if found_extras == 0:
                    # Grab the time line
                    contents[count+10] = re.sub("</td>","",contents[count+10])
                    contents[count+10] = re.sub("\s+\&nbsp\;","",contents[count+10])
                    contents[count+16] = re.sub(pat3,"",contents[count+16])

                    total_time = "Total Est. Time: %s" % (contents[count+10])
                    total_distance = "Total Distance: %s" % (contents[count+16])
                    found_extras=1
            else:
                pass
                
            count = count+1

        if len(matches):
            fg = gtk.GdkColor(0,0,0)
            for match in matches:
                first = "%s %s" % (match[0],match[1])
                second = "Distance: %s\n" % (match[2])
                directions_list.insert_defaults(first)
                directions_list.insert(None,fg,None,second)
                
            directions_list.insert_defaults(total_time)
            directions_list.insert_defaults(total_distance)
                
        else:
            directions_list.insert_defaults("No directions available")
        
        directions_list.thaw()
        
class GladeHelper:
    def __init__(self, glade_file, handler):
        self.widgets = libglade.GladeXML(glade_file)
        self.widgets.signal_autoconnect(handler.__dict__)

    def __getitem__(self, key):
        return self.widgets.get_widget(key)

class ContactSignalHandler:
    def on_edit_button_clicked(widget,*args):
        view = widget.get_data("view")
        view.edit_contact_tab()

    def on_cancel_button_clicked(widget,*args):
        view = widget.get_data("view")
        view.back_to_contact_view()

    def on_save_button_clicked(widget,*args):
        view = widget.get_data("view")
        view.save_contact()

    def on_close_button_clicked(widget,*args):
        view = widget.get_data("view")
        view.close_contact_window()

    def on_name_button_clicked(widget,*args):
        name = widget.get_data("name")
        view = widget.get_data("view")
        view.more_contact_info_tab(name)

    def on_address_button_clicked(widget,*args):
        name = widget.get_data("name")
        view = widget.get_data("view")
        view.more_contact_info_tab(name)

    def on_phone_button_clicked(widget,*args):
        name = widget.get_data("name")
        view = widget.get_data("view")
        view.more_contact_info_tab(name)

    def on_email_button_clicked(widget,*args):
        name = widget.get_data("name")
        view = widget.get_data("view")
        view.more_contact_info_tab(name)

    def on_more_cancel_button_clicked(widget,*args):
        view = widget.get_data("view")
        name = widget.get_data("name")
        view.back_to_contact_edit(name)

    def on_more_save_button_clicked(widget,*args):
        view = widget.get_data("view")
        name = widget.get_data("name")
        view.back_to_contact_edit(name)

    def on_address_combo_changed(widget,*args):
        view = widget.get_data("view")
        view.search_for_possible_addresses(widget)
        
    def on_address_list_select_child(widget,row):
        view = row.get_data("view")
        notebook = view.helper["notebook1"]
        notebook.set_page(6)
        address = row.get_data("address")
        view.get_directions(address)

    def on_directions_back_clicked(widget,*args):
        view = widget.get_data("view")
        view.back_to_contact_view()
