import gtk
import libglade

from familiar.core import *

class Task(FamiliarClass):
    def __init__(self):
        self.mimetype = "application/x-task"
        self.priority = 0
        self.label = "n/a"
        self.description = "n/a"
        FamiliarClass.__init__(self)

    def set_priority(self, priority):
        self.priority = priority

    def get_priority(self):
        return self.priority

    def set_label(self, label):
        self.label = label

    def get_label(self):
        return self.label

    def set_description(self, description):
        self.description = description

    def get_description(self):
        return self.description

    def new_view(self):
        return TaskView(self)


class TaskView(FamiliarClassView):
    def __init__(self, object):
        self.object = object
        FamiliarClassView.__init__(self)

    def view(self):
        self.widgets = libglade.GladeXML("familiar/task.glade")
        label_entry = self.widgets.get_widget("label_entry")
        priority_entry = self.widgets.get_widget("priority_entry")
        description_text = self.widgets.get_widget("description_text")
        
        label_entry.set_text(self.object.get_label())

        priority_entry.set_text("%d" % (self.object.get_priority()))

        description_text.insert_defaults(self.object.get_description())

