from familiar.core import *
import gtk
import GDK
import libglade


class TaskManager(FamiliarClass):
    def __init__(self):
        self.tasks = []
        FamiliarClass.__init__(self)

    def set_manager(self, manager):
        self.manager = manager
        self.refresh_tasks()

    def get_tasks(self):
        return self.tasks

    def refresh_tasks(self):
        self.tasks = self.manager.search_by_type("application/x-task")

    def new_view(self):
        return TaskManagerView(self)



class TaskManagerView(FamiliarClassView):
    def __init__(self, object):
        self.object = object
        FamiliarClassView.__init__(self)

    def view(self):
        self.helper = GladeHelper("familiar/taskmanager.glade",
                                  TaskManagerSignalHandler)

        task_clist = self.helper["task_clist"]

        tasks = self.object.get_tasks()

        for task in tasks:
            row = task_clist.append(["%d" % (task.get_priority()),
                                     task.get_label()])

            task_clist.set_row_data(row, task)
            
            
class GladeHelper:
    def __init__(self, glade_file, handler):
        self.widgets = libglade.GladeXML(glade_file)
        self.widgets.signal_autoconnect(handler.__dict__)

        
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

class TaskManagerSignalHandler:
    def on_taskmanager_window_destroy(*args):
        # XXX - Hrm.. shouldn't be here.
        gtk.mainquit()
        
    def on_task_clist_select_row(clist, row, column, event):
        if event.type == GDK._2BUTTON_PRESS:
            task = clist.get_row_data(row)
            task.new_view().view()


        
